
Button = {
  x = 0,
  y = 0,
  x2 = 0,
  y2 = 0,
  active = false,
  baseColor = white,
  pressedColor = white,
  text = "boobton",
  textColor = white,
  clicked = false,
  background = nil
}
Button.__index = Button

function Button:new(o,x,y,width,height,baseColor,pressedColor,text,textColor,background)
  o = o or {}
  setmetatable(o,Button)
  o.__index = Button
  --turn x,y,w,h to x,x2,y,y2
  o.x      = x-width/2
  o.x2     = x+width/2
  o.y      = y-height/2
  o.y2     = y+height/2
  o.active = true
  o.baseColor = baseColor
  o.pressedColor = pressedColor
  o.text = text
  o.clicked = false
  o.background = background
  return o
end

function Button:isClicked()
  if(self.active) then
    x, y = Controls.readTouch()
    if x and y and
        x>self.x and x<self.x2 and
        y>self.y and y<self.y2 then
      self.clicked = true
    else
      if self.clicked then
        self.clicked = false
        if not x and not y then--click button if fingers have left the screen not left the button
          return true
        end
      end
    end
  end
  return false
end
function Button:getX()
  return (self.x+self.x2)/2
end
function Button:getY()
  return (self.y+self.y2)/2
end
function Button:getWidth()
  return self.x2-self.x
end
function Button:getHeight()
  return self.y2-self.y
end

function Button:render()
  if self.active then
    if not self.clicked then
      color = self.baseColor
    else
      color = self.pressedColor
    end
    if self.background == nil then
      Graphics.fillRect(self.x,self.x2,self.y,self.y2,color)
    else
      Graphics.drawScaleImage(self.x,self.y,self.background,
        self:getWidth()/Graphics.getImageWidth(self.background),
        self:getHeight()/Graphics.getImageHeight(self.background),color)
    end
      Graphics.debugPrint(self:getX()-self.text:len()*4,(self.y+self.y2)/2-10,self.text,self.textColor)
  end
end
